HDU 1069(动态规划)

127 篇文章 0 订阅
85 篇文章 2 订阅

Monkey and Banana

Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others)

Problem Description

A group of researchers are designing an experiment to test the IQ of a monkey. They will hang a banana at the roof of a building, and at the mean time, provide the monkey with some blocks. If the monkey is clever enough, it shall be able to reach the banana by placing one block on the top another to build a tower and climb up to get its favorite food.

The researchers have n types of blocks, and an unlimited supply of blocks of each type. Each type-i block was a rectangular solid with linear dimensions (xi, yi, zi). A block could be reoriented so that any two of its three dimensions determined the dimensions of the base and the other dimension was the height.

They want to make sure that the tallest tower possible by stacking blocks can reach the roof. The problem is that, in building a tower, one block could only be placed on top of another block as long as the two base dimensions of the upper block were both strictly smaller than the corresponding base dimensions of the lower block because there has to be some space for the monkey to step on. This meant, for example, that blocks oriented to have equal-sized bases couldn’t be stacked.

Your job is to write a program that determines the height of the tallest tower the monkey can build with a given set of blocks.

Input

The input file will contain one or more test cases. The first line of each test case contains an integer n,
representing the number of different blocks in the following data set. The maximum value for n is 30.
Each of the next n lines contains three integers representing the values xi, yi and zi.
Input is terminated by a value of zero (0) for n.

Output

For each test case, print one line containing the case number (they are numbered sequentially starting from 1) and the height of the tallest possible tower in the format “Case case: maximum height = height”.

Sample Input

1
10 20 30
2
6 8 10
5 5 5
7
1 1 1
2 2 2
3 3 3
4 4 4
5 5 5
6 6 6
7 7 7
5
31 41 59
26 53 58
97 93 23
84 62 64
33 83 27
0

Sample Output

Case 1: maximum height = 40
Case 2: maximum height = 21
Case 3: maximum height = 28
Case 4: maximum height = 342

问题分析

题意:一群研究人员要测一测小猴纸的智商,所以他们准备把小猴纸最喜爱的banana放到房顶上,给小猴纸们一些方块块,让小猴纸去垒方块爬上去去够香蕉,但是处于上面的方块的长和宽必须都相应的比下面的小,要不然小猴子怎么落脚呀。可是研究人员还怕小猴纸够不到香蕉,就想让你帮忙算一下给出n个方块的长宽高,这些方块组合起来最高的高度是多少。

通过题意我们可以了解到,这些方块的长和宽是由低到高依次递减的,只是高度可能不同而已。不觉得很熟悉嘛?想一想最长上升子序列,每一个元素的值是依次递增的,求的是最长的子序列长度。而这里是一个个方块,如果把方块当做数字来看待的话,那这里也不是同样满足求最长上升子序列的条件吗,只不过每个元素的长度是方块的高度,值大小比较变成了长和宽的比较,然后就变成了求最长递减子序列的升级版了嘛(^_^)。

还有,这里一个方块可以使用多次,只要满足长和宽依次递减就好,所以,一个方块可以有6种使用方式,长宽高依次排列组合一下嘛(A(3,3) = 6)

但是记得这样做得sort一下喔,因为长和宽都是要求严格递减的。

所以状态转移方程是dp[i] = max(dp[i],dp[j]+a[i].z)(j < i, a[j].x > a[i].x&&a[j].y > a[i].y)

好,上AC code(^_^)~

#include <iostream>
#include <algorithm>
#include <string.h>
using namespace std;
const int N = 200;
int dp[N], n, k = 0;

struct block
{
    int x,y,z;
    //让其按照长宽递减的方式来比较方块大小
    friend operator > (block a, block b)
    {
        if(a.x>b.x&&a.y>b.y)
        return true;
        else
        return false;
    }
}a[N];

bool cmp(block a, block b)//给方块排序
{
    if(a.x>b.x)
    return true;
    else if(a.x==b.x)
    return a.y>b.y;
    return false;
}

void turn(int x, int y, int z)
{
    k++;
    a[k].x = x, a[k].y = y, a[k].z = z;
}

int main()
{
    //freopen("in.txt","r",stdin);
    int x,y,z, t = 1;
    while(scanf("%d",&n),n)
    {
        memset(dp,0,sizeof(dp));
        k = 0;
        for(int i = 1; i <= n; i++)
        {
            cin>>x>>y>>z;
            //一个方块可以有6种方式来用
            turn(x,y,z); turn(x,z,y); turn(y,x,z);
            turn(y,z,x); turn(z,x,y); turn(z,y,x);
        }
        sort(a+1,a+k+1,cmp);
        dp[1] = a[1].z;
        for(int i = 2; i <= k; i++)
        {
            dp[i] = a[i].z;
            for(int j = 1; j < i; j++)
            {
                if(a[j]>a[i])
                {
                    dp[i] = max(dp[i],dp[j]+a[i].z);
                }
            }
        }
        int ans = *max_element(dp+1,dp+k+1);
        printf("Case %d: maximum height = %d\n",t++,ans);
    }
    return 0;
}
  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值